# corebridge


<!-- WARNING: THIS FILE WAS AUTOGENERATED! DO NOT EDIT! -->

This package provides functions and classes to run wodan style
processing functions in the Stactics AICore environment.

## Install

``` sh
pip install corebridge
```

## How to use

### Introduction

#### Wodan processing functions

Wodan is a proprietary backend service that applies high performance,
custom analytical processing to timeseries data in the Whysor data and
dashboarding environment.

Each wodan module defines one function that operates as the entry point.
The parameter annotations in this function definition are used to format
data and retrieve parameters from the originating call to the wodan api.
This function is called with data retrieved according to a specification
and with additional parameters as annotated.

A simple function might look like:

``` {python}
import numpy as np

def multiply(data:np.ndarray, multiplier:float=1.0):
    return data * multiplier
    
```

#### AICore modules

For AICore one defines a class, always named `Module` with a constructor
`__init__` and a method `infer`.

This package defines a baseclass to quickly construct a custom `Module`
class that uses a wodan processor function inside the AICore system:

``` {python}
import numpy as np
import corebridge

def multiply(data:np.ndarray, multiplier:float=1.0):
    return data * multiplier

class Module(corebridge.aicorebridge.AICoreModule):
    def __init__(self, save_dir, assets_dir, *args, **kwargs):
        super().__init__(read, save_dir, assets_dir, *args, **kwargs)
    
```

That’s it. Well, you can add parameters to `__init__` that can be used
as hyperparameters and you could override `infer` for the same reason.

``` python
```

    2

## nbdev cycle

- edit
- nbdev_export
- pip install -e ‘.\[dev\]’
- nbdev_test
- nbdev_clean
- nbdev_readme
- nbdev_prepare
- git add .
- 
